//+------------------------------------------------------------------+
//|                                                Grassroot 104.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Aqua
//--- buffers
double ExtMapBuffer1[], ExtMapBuffer2[], ExtMapBuffer3[];
extern double sftr = 0.04;   
extern int priceband_period = 55;
extern int short_period = 30;
extern int long_period = 204;
extern bool show_buysell = false;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars = IndicatorCounted();
   if (counted_bars < 0) return(-1);
    
   double hhv0, hhv1, hhv5, hhv6, llv0, llv1, llv5, llv6, dir0, dir1, dir5, dir6;
   int i, bsig, ssig;
   int cross_up0, cross_dn0, cross_up5, cross_dn5;
   static int signal = 0;   
        
   for(i = Bars-counted_bars-1; i>=0; i--)
   {
      hhv0 = High[iHighest(NULL, 0, MODE_HIGH, priceband_period, i+1)];
      llv0 = Low[iLowest(NULL, 0, MODE_LOW, priceband_period, i+1)];
      dir0 = iMA(NULL, 0, short_period, 0, MODE_EMA, PRICE_CLOSE, i) - iMA(NULL, 0 , long_period, 0, MODE_EMA, PRICE_CLOSE, i);
            
      hhv1 = High[iHighest(NULL, 0, MODE_HIGH, priceband_period, i+2)];
      llv1 = Low[iLowest(NULL, 0, MODE_LOW, priceband_period, i+2)];
      
      hhv5 = High[iHighest(NULL, 0, MODE_HIGH, priceband_period, i+6)];
      llv5 = Low[iLowest(NULL, 0, MODE_LOW, priceband_period, i+6)];
      dir5 = iMA(NULL, 0, short_period, 0, MODE_EMA, PRICE_CLOSE, i+5) - iMA(NULL, 0 , long_period, 0, MODE_EMA, PRICE_CLOSE, i+5);
      
      hhv6 = High[iHighest(NULL, 0, MODE_HIGH, priceband_period, i+7)];
      llv6 = Low[iLowest(NULL, 0, MODE_LOW, priceband_period, i+7)];
      
      cross_up0 = (Close[i] > hhv0 * (1+sftr/100)); //&& (Close[i+1] <= hhv0 * (1+sftr/100));
      cross_dn0 = (Close[i] < llv0 * (1-sftr/100)); //&& (Close[i+1] >= llv0 * (1-sftr/100));
                  
      cross_up5 = (Close[i+5] > hhv5); //&& (Close[i+6] <= hhv6);
      cross_dn5 = (Close[i+5] < llv5); //&& (Close[i+6] >= llv6);

      bsig = (cross_up0 || (cross_up5 && dir5 > 0 && Close[i] > High[i+5])) && (dir0 > 0);
      ssig = (cross_dn0 || (cross_dn5 && dir5 < 0 && Close[i] < Low[i+5])) && (dir0 < 0);

      if(bsig + ssig == 1)
      {
         if(bsig == 1 && signal != 1) 
            signal = 1;
         else 
         if(ssig == 1 && signal != -1) 
            signal = -1;
      }

      if(show_buysell)
      {
         ExtMapBuffer1[i] = bsig;
         ExtMapBuffer2[i] = ssig;
      }
      ExtMapBuffer3[i] = signal;
  }
   
   return(0);
  }
//+------------------------------------------------------------------+